;************************************************************************************
;Grille v3 - Microcontroller Grille - Sept.2009 Alex S.
;Atmel Tiny13 Fuses auf 4,8MHz (bei Ponyprog haken da bei fuses cksel1 sut0 spien)
;Piezo Schallwandler von Portb0 (Pin5) nach Masse (Pin4) 
;Pin 1 (reset) nach Pin 8 (Plus) - Alle anderen Pins bleiben frei
;************************************************************************************



;Registerliste:
;r0  immer 0
;r16 general
;r17 lautstaerke veraenderung abwarten variation
;r18 lautstaerke hoehe variation
;r19 einzelnes zirp wiederholungszaehler
;r20 pulsdauer zaehler
;r21 lautstaerke veraenderung abwarten zaehler
;r22 einzelnes zirp wiederholungszaehler variation
;r23 zirpen lange pause zaehler / zirpen langepausendauer zaehler
;r24 pseudozufall low
;r25 pseudozufall high
;r28 zirpen langepausendauer zaehler variation low / zirpen kurzepausendauer zaehler low
;r29 zirpen langepausendauer zaehler variation high / zirpen kurzepausendauer zaehler high
;r30 zirpen kurze pause zaehler variation low
;r31 zirpen kurze pause zaehler variation high



.include "tn13def.inc"
rjmp start



start:  ldi r16,0b10000000          ;sysclock aenderung anmelden...
        out clkpr,r16               ;...
        ldi r16,0b00000010          ;sysclock geteilt durch 64 (4,8MHz:4=1,2MHz)...
        out clkpr,r16               ;...

        sbi acsr,acd                ;komparator aus (strom sparen)

        ldi r16,0b00000001          ;portb0=ausgang / portb1 bis b4=eingang...
        out ddrb,r16                ;...
        ldi r16,0b00011110          ;portb0=pullup aus / portb1 bis b4 pullup an...
        out portb,r16               ;...

        clr r0                      ;immer 0
        ldi r17,12                  ;lautstaerke veraenderung abwarten variation init
        ldi r18,30                  ;lautstaerke hoehe variation init
        ldi r19,20                  ;einzelnes zirp wiederholungszaehler init
        ldi r20,1                   ;pulsdauer zaehler init
        ldi r21,11                  ;lautstaerke veraendern abwarten zaehler init		
        ldi r22,8                   ;einzelnes zirp wiederholungszaehler variation init
	    ldi r23,8                   ;zirpen lange pause zaehler init
        ldi r24,0b01101101          ;pseudozufall init
 	    ldi r30,low(9000)           ;zirpen kurze pause zaehler variation init...
        ldi r31,high(9000)          ;...



a1:     sbi portb,0                 ;portb0 high (puls an)        

        mov r16,r20                 ;pulsdauer zaehler...
a2:     dec r16                     ;...
        brne a2                     ;...
		
        cbi portb,0                 ;portb0 low (puls aus)

        ldi r16,178                 ;'puls aus' zaehler init...
        sub r16,r20                 ;pulsdauer von 'puls aus' abziehen (pulsweitenmodulation)
a3:     dec r16                     ;...
        brne a3                     ;...
		
        dec r21                     ;lautstaerke veraendern abwarten zaehler...
        brne a1                     ;...
        
        mov r21,r17                 ;lautstaerke veraenderung abwarten zaehler init		
        subi r20,-5                 ;(=add r20,5) lautstaerke erhoehen
        cp r20,r18                  ;lautstaerke hoehe erreicht?...
        brlo a1                     ;...nein dann zu a1
        ldi r20,1                   ;...ja dann lautstaerke wieder 1 
        
        cpi r24,128                 ;pseudozufall low kleiner als 128?...
        brlo x0                     ;...ja dann zu x0
        cpi r17,12                  ;lautstaerke veraenderung abwarten variation auf 12?...
        breq x1                     ;...ja dann zu x1...
        inc r17                     ;...nein dann erhoehen
        rjmp x1 
x0:     cpi r17,11                  ;lautstaerke veraenderung abwarten variation auf 10?...
        breq x1                     ;...ja dann zu x1...
        dec r17                     ;...nein dann senken

x1:     cpi r25,128                 ;pseudozufall high kleiner als 128?...
        brlo x2                     ;...ja dann zu x2
        cpi r18,37                  ;lautstaerke hoehe variation auf 37?... 
        breq x3                     ;...ja dann zu x3...
        inc r18                     ;...nein dann erhoehen...
        rjmp x3 
x2:     cpi r18,27                  ;lautstaerke hoehe variation auf 27?...
        breq x3                     ;...ja dann zu x3...
        dec r18                     ;...nein dann senken

x3:     cpi r24,5                   ;pseudozufall kleiner als 5?...
        brlo x4                     ;...ja dann zu x4
        cpi r22,9                   ;einzelnes zirp wiederholungszaehler variation auf 9?...
        breq x5                     ;...ja dann zu x5...
        inc r22                     ;...nein dann erhoehen
        rjmp x5 
x4:     cpi r22,7                   ;einzelnes zirp wiederholungszaehler variation auf 7?...
        breq x5                     ;...ja dann zu x5...
        dec r22                     ;...nein dann senken

x5:     dec r19                     ;einzelnes zirp wiederholungszaehler...
        brne a1                     ;...
        
        lsl r24                     ;pseudozufall erzeugen (16 bit)...
        rol r25                     ;...
        brcc f0                     ;...
        ori r24,0b00000001          ;...
        ldi r16,0b00101100          ;...
        eor r24,r16                 ;...

f0:     dec r23                     ;zirpen lange pause zaehler...
        brne a3f                    ;...

        mov r23,r24                 ;zirpen langepausendauer zaehler=pseudozufall low wert 
        andi r23,0b00011111         ;maximal 31   
        ori r23,0b00000011          ;minimal 3
        clr r28                     ;zirpen langepausendauer zaehler init...
        clr r29                     ;...
f1:     sbiw r29:r28,1              ;zirpen langepausendauer zaehler...
        lpm                         ;...=3x nop...
        lpm                         ;...=3x nop...
        lpm                         ;...=3x nop...
        lpm                         ;...=3x nop...
        brne f1                     ;...
        dec r23                     ;...    
        brne f1                     ;...
        clr r0                      ;r0 wieder auf 0 wegen lpm
        mov r23,r24                 ;zirpen lange pause zaehler=pseudozufall low wert
        andi r23,0b01111111         ;maximal 127
        ori r23,0b00000011          ;minimal 3       

a3f:    cpi r24,128                 ;pseudozufall low groessergleich 128?...
        brsh a4a                    ;...ja dann zu a4a
        cpi r30,200                 ;zirpen kurze pause zaehler variation auf 200?...
        cpc r31,r0                  ;...
        breq a3a                    ;...ja dann zu a3a...
        sbiw r31:r30,50             ;...nein dann senken...
        sbiw r31:r30,50             ;...
        sbiw r31:r30,50             ;...
        sbiw r31:r30,50             ;...
        rjmp a3a

a4a:    cpi r25,128                 ;pseudozufall high groessergleich 128?...
        brsh a3a                    ;...ja dann zu a3a
        cpi r30,low(15000)          ;zirpen kurze pause zaehler variation auf 15000?...
        ldi r16,high(15000)         ;...
        cpc r31,r16                 ;...
        breq a3a                    ;...ja dann zu a3a...
        adiw r31:r30,50             ;...nein dann erhoehen...
        adiw r31:r30,50             ;...
        adiw r31:r30,50             ;...
        adiw r31:r30,50             ;...

a3a:    mov r19,r22                 ;einzelnes zirp wiederholungszaehler=einzelnes zirp wiederholungszaehler variation
        ldi r28,low(50000)          ;zirpen kurzepausendauer zaehler init...
        ldi r29,high(50000)         ;...
        sub r28,r30                 ;zirpen kurze pause zaehler variation vom endwer abziehen...
        sbc r29,r31                 ;...
w1:     sbiw r29:r28,1              ;zirpen kurzepausendauer zaehler...
        brne w1                     ;...

a4:     rjmp a1 
